
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>贝塞尔曲线基本用法 / 憋错料</title>

    <meta name="description" content="贝塞尔曲线基本用法 使用UIBezierPath可以创建基于矢量的路径,此类是Core Graphics框架关于路径的封装.使用此类可以定义简单的形状,如椭圆.矩形或者有多个直线和曲线段组成的形状等. UIBezierPath是CGPathRef数据类型的封装.如果是基于矢量形状的路径,都用直线和曲线去创建.我们使用直线段去创建矩形和多边形,使用曲线去创建圆弧(arc).圆或者其他复杂的曲线形状. 1.使用UIBezierPath画图步骤: 2.创建一个UIBezierPath对象 3.调用-moveToPoint">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">贝塞尔曲线基本用法</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>使用<code>UIBezierPath</code>可以创建基于矢量的路径，此类是<code>Core Graphics</code>框架关于路径的封装。使用此类可以定义简单的形状，如椭圆、矩形或者有多个直线和曲线段组成的形状等。</p>
<p><code>UIBezierPath</code>是<code>CGPathRef</code>数据类型的封装。如果是基于矢量形状的路径，都用直线和曲线去创建。我们使用直线段去创建矩形和多边形，使用曲线去创建圆弧（arc）、圆或者其他复杂的曲线形状。</p>
<p>1.使用<code>UIBezierPath</code>画图步骤：</p>
<p>2.创建一个<code>UIBezierPath</code>对象</p>
<p>3.调用<code>-moveToPoint:</code>设置初始线段的起点</p>
<p>4.添加线或者曲线去定义一个或者多个子路径</p>
<p>5.改变<code>UIBezierPath</code>对象跟绘图相关的属性。如，我们可以设置画笔的属性、填充样式等</p>
<h1><code>UIBezierPath</code>创建方法介绍</h1>
<p>1.<code>UIBezierPath</code>类提供了哪些创建方式，这些都是工厂方法，直接使用即可。</p>
<pre><code>+ (instancetype)bezierPath;
+ (instancetype)bezierPathWithRect:(CGRect)rect;
+ (instancetype)bezierPathWithOvalInRect:(CGRect)rect;
+ (instancetype)bezierPathWithRoundedRect:(CGRect)rect
                            cornerRadius:(CGFloat)cornerRadius;
+ (instancetype)bezierPathWithRoundedRect:(CGRect)rect
                        byRoundingCorners:(UIRectCorner)corners
                              cornerRadii:(CGSize)cornerRadii;
+ (instancetype)bezierPathWithArcCenter:(CGPoint)center
                                 radius:(CGFloat)radius
                             startAngle:(CGFloat)startAngle
                               endAngle:(CGFloat)endAngle
                              clockwise:(BOOL)clockwise;
+ (instancetype)bezierPathWithCGPath:(CGPathRef)CGPath;</code></pre>
<p>2.下面我们一个一个地介绍其用途。</p>
<p><code>　+ (instancetype)bezierPath;</code></p>
<p>这个使用比较多，因为这个工厂方法创建的对象，我们可以根据我们的需要任意定制样式，可以画任何我们想画的图形。</p>
<p><code>　+ (instancetype)bezierPathWithRect:(CGRect)rect;</code></p>
<p><strong>这个工厂方法根据一个矩形画贝塞尔曲线。</strong></p>
<pre><code>+ (instancetype)bezierPathWithOvalInRect:(CGRect)rect;

</code>这个工厂方法根据一个矩形画内切曲线。通常用它来画圆或者椭圆。</pre>
<pre><code>+ (instancetype)bezierPathWithRoundedRect:(CGRect)rect
                            cornerRadius:(CGFloat)cornerRadius;
+ (instancetype)bezierPathWithRoundedRect:(CGRect)rect
                        byRoundingCorners:(UIRectCorner)corners
                              cornerRadii:(CGSize)cornerRadii;</code>第一个工厂方法是画矩形，但是这个矩形是可以画圆角的。第一个参数是矩形，第二个参数是圆角大小。第二个工厂方法功能是一样的，但是可以指定某一个角画成圆角。像这种我们就可以很容易地给<code>UIView</code>扩展添加圆角的方法了。</pre>
<pre><code>+ (instancetype)bezierPathWithArcCenter:(CGPoint)center
                                 radius:(CGFloat)radius
                             startAngle:(CGFloat)startAngle
                               endAngle:(CGFloat)endAngle
                              clockwise:(BOOL)clockwise;</code>这个工厂方法用于画弧，参数说明如下：<code>center</code>: 弧线中心点的坐标<code>radius</code>: 弧线所在圆的半径<code>startAngle</code>: 弧线开始的角度值<code>endAngle</code>: 弧线结束的角度值<code>clockwise</code>: 是否顺时针画弧线

以下显示代码都在 <code>-(void)drawRect:(CGRect)rect</code>方法中调用</pre>
<h1>画三角形</h1>
<pre>#pragma mark-------- 画三角形- (void)drawTrianglePath {&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; UIBezierPath *path = [UIBezierPath bezierPath];&nbsp;&nbsp;&nbsp; [path moveToPoint:CGPointMake(20, 20)];&nbsp;&nbsp;&nbsp; [path addLineToPoint:CGPointMake(self.frame.size.width - 40, 20)];&nbsp;&nbsp;&nbsp; [path addLineToPoint:CGPointMake(self.frame.size.width / 2, self.frame.size.height - 20)];&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; // 最后的闭合线是可以通过调用closePath方法来自动生成的，也可以调用-addLineToPoint:方法来添加&nbsp;&nbsp;&nbsp; //&nbsp; [path addLineToPoint:CGPointMake(20, 20)];&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; [path closePath];&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; // 设置线宽&nbsp;&nbsp;&nbsp; path.lineWidth = 1.5;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; // 设置填充颜色,三角形的内部填充色&nbsp;&nbsp;&nbsp; UIColor *fillColor = [UIColor greenColor];&nbsp;&nbsp;&nbsp; [fillColor set];&nbsp;&nbsp;&nbsp; [path fill];&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; // 设置画笔颜色&nbsp;&nbsp;&nbsp; UIColor *strokeColor = [UIColor blueColor];&nbsp;&nbsp;&nbsp; [strokeColor set];&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; // 根据我们设置的各个点连线&nbsp;&nbsp;&nbsp; [path stroke];}</pre>
<h1>画矩形</h1>
<pre>#pragma mark-------- 画矩形- (void)drawRectPath {&nbsp;&nbsp;&nbsp; UIBezierPath *path = [UIBezierPath bezierPathWithRect:CGRectMake(20, 20, self.frame.size.width - 100, self.frame.size.height - 300)];&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; path.lineWidth = 1.5;&nbsp;&nbsp;&nbsp; path.lineCapStyle = kCGLineCapRound;&nbsp;&nbsp;&nbsp; path.lineJoinStyle = kCGLineJoinBevel;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; // 设置填充颜色&nbsp;&nbsp;&nbsp; UIColor *fillColor = [UIColor greenColor];&nbsp;&nbsp;&nbsp; [fillColor set];&nbsp;&nbsp;&nbsp; [path fill];&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; // 设置画笔颜色&nbsp;&nbsp;&nbsp; UIColor *strokeColor = [UIColor blueColor];&nbsp;&nbsp;&nbsp; [strokeColor set];&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; // 根据我们设置的各个点连线&nbsp;&nbsp;&nbsp; [path stroke];}<code>lineCapStyle</code>属性是用来设置线条拐角帽的样式的，其中有三个选择：</pre>
<pre><code>typedef CF_ENUM(int32_t, CGLineCap) {
    kCGLineCapButt,
    kCGLineCapRound,
    kCGLineCapSquare
};</code>

其中，第一个是默认的，第二个是轻微圆角，第三个正方形。

<code>lineJoinStyle</code>属性是用来设置两条线连结点的样式，其中也有三个选择：</pre>
<pre><code>typedef CF_ENUM(int32_t, CGLineJoin) {
    kCGLineJoinMiter,
    kCGLineJoinRound,
    kCGLineJoinBevel
};</code>其中，第一个是默认的表示斜接，第二个是圆滑衔接，第三个是斜角连接。</pre>
<h1>画圆</h1>
<pre>我们可以使用<code>+ bezierPathWithOvalInRect:</code>方法来画圆，当我们传的<code>rect</code>参数是一下正方形时，画出来的就是圆。#pragma mark-------画圆形--注意：要画圆，我们需要传的rect参数必须是正方形哦！- (void)drawCiclePath {&nbsp;&nbsp;&nbsp; // 传的是正方形，因此就可以绘制出圆了&nbsp;&nbsp;&nbsp; UIBezierPath *path = [UIBezierPath bezierPathWithOvalInRect:CGRectMake(20, 20, self.frame.size.width - 40, self.frame.size.width - 40)];&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; // 设置填充颜色&nbsp;&nbsp;&nbsp; UIColor *fillColor = [UIColor greenColor];&nbsp;&nbsp;&nbsp; [fillColor set];&nbsp;&nbsp;&nbsp; [path fill];&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; // 设置画笔颜色&nbsp;&nbsp;&nbsp; UIColor *strokeColor = [UIColor blueColor];&nbsp;&nbsp;&nbsp; [strokeColor set];&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; // 根据我们设置的各个点连线&nbsp;&nbsp;&nbsp; [path stroke];}</pre>
<h1>画椭圆</h1>
<p>前面我们已经画圆了，我们可以使用<code>+ bezierPathWithOvalInRect:</code>方法来画圆，当我们传的<code>rect</code>参数是一下正方形时，画出来的就是圆。那么我们要是不传正方形，那么绘制出来的就是椭圆了。</p>
<pre><code>// 画椭圆
- (void)drawOvalPath {
  // 传的是不是正方形，因此就可以绘制出椭圆圆了
  UIBezierPath *path = [UIBezierPath bezierPathWithOvalInRect:CGRectMake(20, 20, self.frame.size.width - 80, self.frame.size.height - 40)];

  // 设置填充颜色
  UIColor *fillColor = [UIColor greenColor];
  [fillColor set];
  [path fill];

  // 设置画笔颜色
  UIColor *strokeColor = [UIColor blueColor];
  [strokeColor set];

  // 根据我们设置的各个点连线
  [path stroke];
}</code></pre>
<h1>画带圆角的矩形</h1>
<pre><code>+ (instancetype)bezierPathWithRoundedRect:(CGRect)rect
                            cornerRadius:(CGFloat)cornerRadius;
+ (instancetype)bezierPathWithRoundedRect:(CGRect)rect
                        byRoundingCorners:(UIRectCorner)corners
                              cornerRadii:(CGSize)cornerRadii;</code>第一个工厂方法是画矩形，但是这个矩形是可以画圆角的。第一个参数是矩形，第二个参数是圆角大小。第二个工厂方法功能是一样的，但是可以指定某一个角画成圆角。像这种我们就可以很容易地给<code>UIView</code>扩展添加圆角的方法了。#pragma mark-------- 画带圆角的矩形- (void)drawRoundedRectPath {#if 0&nbsp;&nbsp;&nbsp; //四个都是圆角10&nbsp;&nbsp;&nbsp; UIBezierPath *path = [UIBezierPath bezierPathWithRoundedRect:CGRectMake(20, 20, self.frame.size.width - 40, self.frame.size.height - 40) cornerRadius:10];

#else&nbsp;&nbsp;&nbsp; // 如果要画只有一个角是圆角，那么我们就修改创建方法：&nbsp;&nbsp;&nbsp; UIBezierPath *path = [UIBezierPath bezierPathWithRoundedRect:CGRectMake(20, 20, self.frame.size.width - 40, self.frame.size.height - 40) byRoundingCorners:UIRectCornerTopRight cornerRadii:CGSizeMake(20, 20)];　　其中第一个参数一样是传了个矩形，第二个参数是指定在哪个方向画圆角，第三个参数是一个<code>CGSize</code>类型，用来指定水平和垂直方向的半径的大小。#endif&nbsp;&nbsp; &nbsp;

&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; // 设置填充颜色&nbsp;&nbsp;&nbsp; UIColor *fillColor = [UIColor greenColor];&nbsp;&nbsp;&nbsp; [fillColor set];&nbsp;&nbsp;&nbsp; [path fill];&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; // 设置画笔颜色&nbsp;&nbsp;&nbsp; UIColor *strokeColor = [UIColor blueColor];&nbsp;&nbsp;&nbsp; [strokeColor set];&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; // 根据我们设置的各个点连线&nbsp;&nbsp;&nbsp; [path stroke];}</pre>
<h1>画弧</h1>
<p>画弧前，我们需要了解其参考系，如下图（图片来自网络）：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvdXBsb2FkLWltYWdlcy5qaWFuc2h1LmlvL3VwbG9hZF9pbWFnZXMvMTI1NTU0Ny02ZTU0YmQwN2Y1MDBlODhkP2ltYWdlTW9ncjIvYXV0by1vcmllbnQvc3RyaXAlN0NpbWFnZVZpZXcyLzIvdy8xMjQw.jpg" /></p>
<p>　　　　　　　　　　　　image</p>
<pre></pre>
<pre><code>#define   kDegreesToRadians(degrees)  ((pi * degrees)/ 180)
- (void)drawARCPath {
  const CGFloat pi = 3.14159265359;

  CGPoint center = CGPointMake(self.frame.size.width / 2, self.frame.size.height / 2);
  UIBezierPath *path = [UIBezierPath bezierPathWithArcCenter:center
                                                      radius:100
                                                  startAngle:0
                                                    endAngle:kDegreesToRadians(135)
                                                   clockwise:YES];

  path.lineCapStyle = kCGLineCapRound;
  path.lineJoinStyle = kCGLineJoinRound;
  path.lineWidth = 5.0;

  UIColor *strokeColor = [UIColor redColor];
  [strokeColor set];

  [path stroke];
}我们要明确一点，画弧参数startAngle和endAngle使用的是弧度，而不是角度，因此我们需要将常用的角度转换成弧度。对于效果图中，我们设置弧的中心为控件的中心，起点弧度为0，也就是正东方向，而终点是135度角的位置。如果设置的clockwise:YES是逆时针方向绘制，如果设置为NO，这两者正好是相反的。</code></pre>
<h1>画二次贝塞尔曲线</h1>
<hr />
<br />先来学习一下关于控制点，如下图（图片来自网络）：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvdXBsb2FkLWltYWdlcy5qaWFuc2h1LmlvL3VwbG9hZF9pbWFnZXMvMTI1NTU0Ny05OWMxYzYxMTMwNjA3MzU4LmpwZWc/aW1hZ2VNb2dyMi9hdXRvLW9yaWVudC9zdHJpcCU3Q2ltYWdlVmlldzIvMi93LzEyNDA=.jpg" /></p>
<p>画二次贝塞尔曲线，是通过调用此方法来实现的：</p>
<pre><code>- (void)addQuadCurveToPoint:(CGPoint)endPoint controlPoint:(CGPoint)controlPoint<code>endPoint</code>：终端点&lt;br/&gt;<code>controlPoint</code>：控制点，对于二次贝塞尔曲线，只有一个控制点

</code></pre>
<pre><code>- (void)drawSecondBezierPath {
  UIBezierPath *path = [UIBezierPath bezierPath];

  // 首先设置一个起始点
  [path moveToPoint:CGPointMake(20, self.frame.size.height - 100)];

  // 添加二次曲线
  [path addQuadCurveToPoint:CGPointMake(self.frame.size.width - 20, self.frame.size.height - 100)
               controlPoint:CGPointMake(self.frame.size.width / 2, 0)];

  path.lineCapStyle = kCGLineCapRound;
  path.lineJoinStyle = kCGLineJoinRound;
  path.lineWidth = 5.0;

  UIColor *strokeColor = [UIColor redColor];
  [strokeColor set];

  [path stroke];
}</code></pre>
<h1>画三次贝塞尔曲线</h1>
<hr />
<br />贝塞尔曲线必定通过首尾两个点，称为端点；中间两个点虽然未必要通过，但却起到牵制曲线形状路径的作用，称作控制点。关于三次贝塞尔曲线的控制器，看下图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvdXBsb2FkLWltYWdlcy5qaWFuc2h1LmlvL3VwbG9hZF9pbWFnZXMvMTI1NTU0Ny0yYjdkYmM5YjU3N2U2ZDU3LmpwZWc/aW1hZ2VNb2dyMi9hdXRvLW9yaWVudC9zdHJpcCU3Q2ltYWdlVmlldzIvMi93LzEyNDA=.jpg" /></p>
<p>提示：其组成是起始端点+控制点1+控制点2+终止端点</p>
<p>如下方法就是画三次贝塞尔曲线的关键方法，以三个点画一段曲线，一般和<code>-moveToPoint:</code>配合使用。</p>
<pre><code>- (void)addCurveToPoint:(CGPoint)endPoint
          controlPoint1:(CGPoint)controlPoint1
          controlPoint2:(CGPoint)controlPoint2</code>
</pre>
<pre><code>- (void)drawThirdBezierPath {
  UIBezierPath *path = [UIBezierPath bezierPath];

  // 设置起始端点
  [path moveToPoint:CGPointMake(20, 150)];

  [path addCurveToPoint:CGPointMake(300, 150)
          controlPoint1:CGPointMake(160, 0)
          controlPoint2:CGPointMake(160, 250)];

  path.lineCapStyle = kCGLineCapRound;
  path.lineJoinStyle = kCGLineJoinRound;
  path.lineWidth = 5.0;

  UIColor *strokeColor = [UIColor redColor];
  [strokeColor set];

  [path stroke];
}</code>

我们需要注意，这里确定的起始端点为(20,150)，终止端点为(300, 150)，基水平方向是一致的。控制点1的坐标是（160，0），水平方向相当于在中间附近，这个参数可以调整。控制点2的坐标是（160，250），如 果以两个端点的连线为水平线，那么就是250-150=100，也就是在水平线下100。这样看起来就像一个<code>sin</code>函数了。</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-12 07:04:26 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>贝塞尔曲线基本用法的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/v0k28pM.html" rel="bookmark">【开源项目解析】QQ&OpenCurlyDoubleQuote;一键下班&rdquo;功能实现解析&mdash;&mdash;学习Path及贝塞尔曲线的基本使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				早在很久很久以前,QQ就实现了&quot;一键下班&quot;功能.何为&quot;一键下班&quot;?当你QQ有信息时,下部会有信息数量提示红点,点击拖动之后,就会出现&quot;一键下班&quot;效果.本文将结合github上关于此功能的一个简单实现,介绍这个功能的基本实现思路. 项目地址 https://github.com/chenupt/BezierDemo 最终实现效果 实现原理解析 我个人感觉,这个效果实现的很漂亮啊!那么咱们就来看看实现原理是什么~ 注:下面内容请参照项目源码观看. 其			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4APwov3.html" rel="bookmark">IOS用CGContextRef画各种图形&lpar;文字、圆、直线、弧线、矩形、扇形、椭圆、三角形、圆角矩形、贝塞尔曲线、图片&rpar;&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Graphics Context是图形上下文,可以将其理解为一块画布,我们可以在上面进行绘画操作,绘制完成后,将画布放到我们的view中显示即可,view看作是一个画框. 自己学习时实现的demo,希望对大家有帮助,具体的实现看代码,并有完美的注释解释,还有一些对我帮助的博文供大家参考.都在代码里面. 看一下demo效果图先: 自定义CustomView类,CustomView.h: [cpp]  view plain copy #import &lt;UIKit/UIKit.h&gt; #import 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xQben3.html" rel="bookmark">贝塞尔曲线与CSS3动画、SVG和canvas的应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介 贝塞尔曲线是可以做出很多复杂的效果来的,比如弹跳球的复杂动画效果,首先加速下降,停止,然后弹起时逐渐减速的效果. 使用贝塞尔曲线常用的两个网址如下: 缓动函数:http://www.xuanfengge.com/easeing/easeing/ cubic-bezier:http://cubic-bezier.com/ 如何用贝塞尔曲线画曲线 一个标准的3次贝塞尔曲线需要4个点:起始点.终止点(也称锚点)以及两个相互分离的中间点. 无论SVG, Canvas还是CSS3动画,都牵扯到这4个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rkyo14.html" rel="bookmark">深度掌握SVG路径path的贝塞尔曲线指令</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.数字.公式.函数.变量,哦,NO! 又又一次说起贝塞尔曲线(英语:Bézier curve,维基百科详尽中文释义戳这里),我最近在尝试实现复杂的矢量图形动画,发现对贝塞尔曲线的理解馒头那么厚,是完全不能承受富有创意的创作的,至少得有我当年追我老婆的脸皮厚才行. 然而,瞅瞅维基百科上的释义,或者其他一些相关的技术文章,总是离不开各种公式,一大堆变量……例如下面维基截图缩略图: 完全是数学爱好者的菜啊!我想,要是让UI设计师们去学习这些东西,估计还不如一刀来个痛快的! 这就是爱好领域与能力掌握的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NyrdZ3.html" rel="bookmark">贝塞尔曲线 &amp;amp&semi; CAShapeLayer  &amp;amp&semi; Stroke 动画 浅谈</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载自:http://46aae4d1e2371e4aa769798941cef698.devproxy.yunshipei.com/qiaoqiaoqiao2014/article/details/46928787 1.CAShapeLayer简介  1.1CAShapeLayer继承于CALayer,可以使用CALayer的所有属性值:    1.2CAShapeLayer需要贝塞尔曲线配合使用才有意义(也就是说才有效果)    1.3使用CAShapeLayer(属于CoreAnimati			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RjZr90.html" rel="bookmark">html5 canvas绘图&mdash;三次方贝塞尔曲线</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们知道二次方贝塞尔曲线,那些曲线都是二维的,意思就是说,它们都只能向一个方向弯曲.如果需要如图这样,能够向两个方向弯曲的曲线,那么你需要的就是三次贝塞尔曲线. 该图所示应用程序使用bezierCurveTo()方法创建了一条代表三次方贝塞尔曲线的路径.该应用程序的代码列在了下面的程序清单中. 这段代码除了绘制曲线本身,还填充了表示曲线控制点与锚点的小圆圈. html代码: 1 &lt;html&gt; 2 &lt;head&gt; 3 &lt;title&gt;Bezier Curves&lt;/tit			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgmLxn3.html" rel="bookmark">贝塞尔曲线：原理、自定义贝塞尔曲线View、使用！！！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.原理 转自:http://www.2cto.com/kf/201401/275838.html Android动画学习Demo(3) 沿着贝塞尔曲线移动的Property Animation Property Animation中最重要,最基础的一个类就是ValueAnimator了.Property Animation利用ValueAnimator来跟踪记录对象属性已经变化了多长时间及当前这个时间点的值. 而在ValueAnimator中,又封装了两个类: 1)TimeInterpolat			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aodlA4.html" rel="bookmark">安卓自定义 View 进阶：贝塞尔曲线</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上一篇文章Path之基本图形中我们了解了Path的基本使用方法,本次了解Path中非常非常非常重要的内容-贝塞尔曲线. 一.Path常用方法表 为了兼容性(偷懒) 本表格中去除了在API21(即安卓版本5.0)以上才添加的方法.忍不住吐槽一下,为啥看起来有些顺手就能写的重载方法要等到API21才添加上啊.宝宝此刻内心也是崩溃的. 作用相关方法备注 移动起点moveTo移动下一次操作的起点位置 设置终点setLastPoint重置当前path中最后一个点位置,如果在绘制之前调用,效果和moveT			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEOGZR3.html" rel="bookmark">Android自定义View进阶 - 贝塞尔曲线</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Path之贝塞尔曲线 作者微博: @GcsSloop [本系列相关文章] 在上一篇文章Path之基本图形中我们了解了Path的基本使用方法,本次了解Path中非常非常非常重要的内容-贝塞尔曲线. 一.Path常用方法表 为了兼容性(偷懒) 本表格中去除了在API21(即安卓版本5.0)以上才添加的方法.忍不住吐槽一下,为啥看起来有些顺手就能写的重载方法要等到API21才添加上啊.宝宝此刻内心也是崩溃的. 作用 相关方法 备注 移动起点 moveTo 移动下一次操作的起点位置 设置终点 setLa			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47NRoY3.html" rel="bookmark" class="title">PTPX Power Analysis Flow</a>
					<div>
						PrimeTime PX工具是PrimeTime工具内的一个feature. PTPX的功耗分析,可以报告出chip,block,cell的各个level的功耗. 使用PTPX可以分析的功耗的方式:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0awnQA4.html" rel="bookmark" class="title">Javascript中length属性的总结</a>
					<div>
						Javascript中length属性的总结 一.StringObject中的length     length属性是返回字符串的字符数目. 例如: // 普通字符串 var str = &quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xRZgN4.html" rel="bookmark" class="title">java将图片转换成二进制</a>
					<div>
						package com.oumyye.图片; import java.awt.image.BufferedImage; import java.io.ByteArrayInputStream; imp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyK7oa3.html" rel="bookmark" class="title">OC 类目、协议</a>
					<div>
						类目:为现有的类添加新方法 1.需要添加该类的新方法,但是不能继承该类的情况下 类目使用需要注意的问题: 1.类目里面不能添加实例变量,但是类目可以声明属性,但必须实现set get 方法,在这两个实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pz6rR0.html" rel="bookmark" class="title">Codeforces Round &num;423&lpar;div 2&rpar;</a>
					<div>
						A =w= B QvQ C(并查集) 题意: 你需要根据要求构出一个字符串S 输入n个子串以及这些子串在S中出现的位置(有多个位置),输入数据保证不冲突 然后你根据这些已知子串去构一个字典序最小的S( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/478o26M.html" rel="bookmark" class="title">Python编写微信打飞机小游戏（七）</a>
					<div>
						这边博客我们为大型敌机和中型敌机设置血量并以血槽的形式显示出来,同时解决之前遇到的声道阻塞的BUG(声道阻塞的问题详见之前的博文). 1.为敌机添加表示血量的成员变量 所谓敌机血量,就是指敌机在挂掉之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49L55p3.html" rel="bookmark" class="title">MySQL对数据操作的一些深入语法</a>
					<div>
						其他数据操作 数据的操作也叫作crud: C:create R:read U:update D:delete 插入数据 蠕虫复制 就是在已有的数据的基础之上,将原来的数据进行复制,插入到相对应的表中! ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jeEqVM.html" rel="bookmark" class="title">寺险怂恼刻k7o3sxa618o2uskvoov9</a>
					<div>
						首页时政国际国内财经文娱生活图片视频专栏双语爱出国 移动新媒体 中国搜索 中文国际 &gt; 独家 香港富商刘銮雄斥4.8亿购两颗巨钻赠爱女 曾因行贿被判刑 中国日报网信莲2015-11-12 17: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vjqNZ3.html" rel="bookmark" class="title">&lbrack;Groovy&rsqb; List和Map用法搜集</a>
					<div>
						http://chenfeng0104.iteye.com/blog/609075 http://www.cnblogs.com/muzi1994/p/5169928.html https://zhi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzEmeA4.html" rel="bookmark" class="title">Eclipse使用过程的一些配置、错误等的总结记录</a>
					<div>
						背景:公司项目使用jdk1.6.tomcat7.SVN,本文总结使用到现在的一些配置和问题. 1.Eclipse项目几点配置:(1)Windows -&gt; Preferences -&gt; Ja ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aRqbE3.html" rel="bookmark" class="title">Mysql占用过高CPU时的优化手段</a>
					<div>
						Mysql占用CPU过高的时候,该从哪些方面下手进行优化?占用CPU过高,可以做如下考虑:1)一般来讲,排除高并发的因素,还是要找到导致你CPU过高的哪几条在执行的SQL,show processli ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBW2zY0.html" rel="bookmark" class="title">工作小事</a>
					<div>
						领导对A君说 你把 新版本发布后,下午做统计导出.做完之后帮B君剩下的统计导出做了.B君有事请假了.A君在领导发布任务的时候没看要做的功能,领导又只是简单说了下,没有具体说怎么做.到了下午,A君做的时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RjXkp0.html" rel="bookmark" class="title">CURL超时时间设置</a>
					<div>
						一次完整的http请求,一般包含三个步骤: 通过DNS把域名解析成IP 通过IP地址连接到目标主机 获取目标主机数据(1.给目标主机输出http请求头,以\r\n\r\n结尾:2.获取目标主机传过来的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nw2pp3.html" rel="bookmark" class="title">关于c&num;调用c&sol;c&plus;&plus; dll遇到的问题总结</a>
					<div>
						前段时间公司做了个winform程序,需要调用c 的dll去读取卡号的程序,期间遇到些问题,下面来分享下 一.dll路径问题 相信很多开发者都会遇到这个问题,我总结了下我现在有3总方式去解决这个问题: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47251o3.html" rel="bookmark" class="title">PP- Work center -- Key for performance Efficiency Rate</a>
					<div>
						Purpose : Performance Efficiency Rate Key Performance efficiency rate keys are assigned in the Basic ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZOJdD4.html" rel="bookmark" class="title">数据分析中的变量分类</a>
					<div>
						数据分析工作每天要面对各种各样的数据,每种数据都有其特定的含义.使用范围和分析方法,同一个数据在不同环境下的意义也不一样,因此我们想要选择正确的分析方法,得出正确的结论,首先要明确分析目的,并准确理解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLqK1B0.html" rel="bookmark" class="title">&lbrack;XJOI&rsqb;noip43 T2多人背包</a>
					<div>
						多人背包 DD 和好朋友们要去爬山啦!他们一共有 K 个人,每个人都会背一个包.这些包的容量是相同的,都是 V.可以装进背包里的一共有 N 种物品,每种物品都有给定的体积和价值.在 DD 看来,合理的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mzjj6kM.html" rel="bookmark" class="title">利用AngularJS 实现一个 Single Page App</a>
					<div>
						看了下angular 的route,用它做个非常简单的单页面应用,记录一下. 顺便说下,好处是,页面改变时不需要刷新,而每个页面都展现不同的数据.尤其在使用模板页的时候,非常方便. 一 示例 项目结构 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jbYXW0.html" rel="bookmark" class="title">Codeforces Round &num;288 &lpar;Div&period; 2&rpar; A&comma;B&comma;C&comma;D&comma;E</a>
					<div>
						A:一个一个点向图里面加,判断其所在的位置与其他的点是否可以构成小矩形就可以了. B:贪心,如果前面的偶数有比他小的就找到一个最靠前的交换,如果前面的偶数都比它小,就找一个最靠后的交换. C:贪心,把 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVbD2xM.html" rel="bookmark" class="title">wxpython学习笔记</a>
					<div>
						一.简介 wxPython是Python编程语言的一个GUI工具箱.他使得Python程序员能够轻松的创建具有健壮.功能强大的图形用户界面的程序.它是Python语言对流行的wxWidgets跨平台G ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
